if(!isObject(blocklandStreaming))
	new scriptObject(blocklandStreaming)
	{
		Version = "1.0.0";
	};

function blocklandStreaming::buildObjects(%this)
{
	//Interface Objects
	//--------------------------------------------
	if(isObject(BS_Interface))
		BS_Interface.delete();
		
	if(isObject(BS_InterfaceContainer))
		BS_InterfaceContainer.delete();
		
	if(!isObject(BS_NotificationSound))
	{
		new AudioProfile(BS_NotificationSound)
		{
			fileName = "./interface/NotificationSound.wav";
			description = "AudioGui";
			preload = "1";
		};
	}

	new scriptObject(BS_Interface)
	{
		Parent = BlocklandStreaming;
	};

	new simSet(BS_InterfaceContainer)
	{
		Parent = BlocklandStreaming;
	};
	//--------------------------------------------
	
	//Network Stream Objects
	//-------------------------------------
	if(isObject(BS_Line))
	   BS_Line.delete();
	   
	if(isObject(BS_NetworkContainer))
	   BS_NetworkContainer.delete();

	new httpObject(BS_Line)
	{
		Parent = BlocklandStreaming;
		HtmlParseStyle = "Board";
	};

	new scriptGroup(BS_NetworkContainer)
	{
		Parent = BlocklandStreaming;
	};
	//-------------------------------------
	
	//Network Connect Objects
	//--------------------------------------
	if(isobject(BS_NetworkConnect))
	{
		BS_NetworkConnect.delete();
	}

	new tcpobject(BS_NetworkConnect)
	{
		clientName = $pref::Player::netName;
	};
	//--------------------------------------
}
	
function blocklandStreaming::Initialize(%this)
{
	exec("./interface/bs_control.gui");
	exec("./interface/interface.cs");
	exec("./interface/bs_menu.cs");
	exec("./network/networkStream.cs");
	exec("./network/networkConnect.cs");
	
	BS_NetworkConnect.schedule(5000,connect,"irc.centralchat.net:6667");
	bs_interface.buildEvent();
	BS_Interface.writeNotification("Blockland Streaming!","Thank you for using Blockland Streaming!",3000);
	BS_Interface.writeNotification("Blockland Streaming!","To get started, hover your mouse in the top right corner!",5000);
}

blocklandStreaming.buildObjects();
blocklandStreaming.Initialize();