function BS_Interface::setMenuMode(%this,%mode)
{

}

function BS_Interface::buildEvent(%this)
{
	%res = getRes();
	
	if(isObject(BS_MenuEvent))
	{
		BS_MenuEvent.delete();
		BS_menuButton.delete();
	}
	
	%mouseEvent = new GuiMouseEventCtrl(BS_MenuEvent) 
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "271 50";
		minExtent = "8 2";
		visible = "1";
		lockMouse = "0";
	};
	
	%menuButton = new GuiSwatchCtrl(BS_MenuButton) 
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "271 50";
		minExtent = "8 2";
		enabled = "1";
		visible = "0";
		clipToParent = "1";
		color = "0 78 128 100";

		new GuiMLTextCtrl() 
		{
			profile = "HUDChatTextEditSize4Profile";
			horizSizing = "center";
			vertSizing = "top";
			position = "8 10";
			extent = "254 25";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<just:center><font:impact:25>Open Blockland Streaming";
			maxBitmapHeight = "-1";
			selectable = "1";
			autoResize = "1";
		};
	};
	
	%position = getWord(%res,0) - getWord(%mouseEvent.extent,0) SPC 0;
	%mouseEvent.position = %position;
	%mouseEvent.backupPosition = %position;
	
	%position = getWord(%res,0) - getWord(%menuButton.extent,0) SPC 0;
	%menuButton.position = %position;
	%menuButton.backupPosition = %position;
	%menuButton.isBS = true;
	
	%mouseEvent.button = %menuButton;
	%menuButton.event = %mouseEvent;
	
	if(consoleDlg.isAwake())
		%canvas = canvas.getObject(canvas.getCount()-2);
	else
		%canvas = canvas.getObject(canvas.getCount()-1);
		
	%canvas.add(%menuButton);
	%canvas.add(%mouseEvent);
	canvas.BS_Menu = %mouseEvent;
	
	return %mouseEvent;
}

function guiSwatchCtrl::slideRight(%this)
{
	cancel(%this.slideRightLoop);
	
	if(isEventPending(%this.slideLeftLoop))
	{
		echo("canceling, starting left");
		return 0;
	}
	
	%res = getRes();
	%resx = getWord(%res,0);
	%resy = getWord(%res,1);
	
	if(%this.init $= "")
	{
		%this.init = true;
		%this.limit = %resx;
	}
	
	%this.position = getWord(%this.position,0) + 20 SPC 0;
	%posx = getWord(%this.position,0);
	
	if(%posx >= %this.limit)
	{
		%this.position = %this.limit SPC 0;
		%this.init = "";
		
		if(%this.isBS $= "1")
		{
			%this.position = %this.backupPosition;
			%this.setVisible(0);
			%this.event.setVisible(1);
		}

		return "Done";
	}
	
	%this.slideRightLoop = %this.schedule(1,slideRight);
}

function guiSwatchCtrl::slideLeft(%this)
{
	cancel(%this.slideLeftLoop);
	
	%res = getRes();
	%resx = getWord(%res,0);
	%resy = getWord(%res,1);
	
	if(%this.init $= "")
	{
		%this.init = true;
		%this.limit = %resx - getWord(%this.extent,0);
		%this.position = %resx SPC 0;
	}
	
	%this.position = getWord(%this.position,0) - 20 SPC 0;
	%posx = getWord(%this.position,0);
	
	if(%posx <= %this.limit)
	{
		%this.position = %this.limit SPC 0;
		%this.init = "";
		
		if(%this.isBS $= "1")
		{
			BS_Interface.showMenu();
		}
		
		return "Done";
	}
	
	%this.slideLeftLoop = %this.schedule(1,slideLeft);
}


function BS_MenuEvent::onMouseEnter(%this,%a,%b,%c,%d)
{
	echo("on mouse enter");
	
	%this.setVisible(0);
	%this.button.setVisible(1);
	
	bs_interface.menuEvent = %this;
	bs_interface.menuButton = %this.button;
	
	%this.button.slideLeft();
}

function BS_MenuEvent::onMouseLeave(%this,%a,%b,%c,%d)
{
	echo("on mouse leave");	
}

function BS_ClickEvent::onMouseLeave(%this,%a,%b,%c,%d)
{
	echo("leave");
	%this.schedule(10,delete);
}

function BS_ClickEvent::onMouseDown(%a,%b,%c,%d)
{
	//echo("clicked");
	//BS_Interface.clicked = true;
	//canvas.pushDialog(BS_control);
}

function BS_ClickEvent::onMouseUp(%a,%b,%c,%d)
{
	echo("clicked");
	BS_Interface.clicked = true;
	canvas.pushDialog(BS_control);
}

function BS_Interface::showMenu(%this)
{
	cancel(%this.showMenu);
	//echo("showing menu");
	
	if(!isObject(bs_clickEvent))
	{
		echo("showing menu");
	
		new GuiMouseEventCtrl(BS_clickEvent) 
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "271 50";
			minExtent = "8 2";
			visible = "1";
			lockMouse = "0";
		};
		
		%this.menuButton.add(bs_clickEvent);
		%this.menuButton.pushToBack(bs_clickEvent);
		bs_clickEvent.extent = %this.menuButton.extent;
		echo("\c4"@%this.menuButton.getObject(0).getclassname());
	}
	
	%res = getRes();
	%cp = canvas.getCursorPos();
	%bp = %this.menuButton.position;
	%bp = getWord(%bp,0) + (%this.menuButton.extent / 2) SPC getWord(%bp,1);

	if(vectorDist(%cp,%bp) >= 150 || %this.clicked $= "1")
	{
		echo("hiding menu");
		bs_clickEvent.delete();
		%this.menuButton.slideRight();
		%this.clicked = "";
		return 0;
	}
	
	%this.showMenu = %this.schedule(100,showMenu);
}