//**************************************************************
//********* Notification Object - Building Blocks **************
//**************************************************************


//            Creates and writes to a notification object
//--------------------------------------------------------------------
function BS_Interface::writeNotification(%this,%headString,%bodyString,%breakTime)
{
	//Initialize
	//--------------------------------------
	%container = BS_InterfaceContainer;
	%containerCount = %container.getCount();
	//--------------------------------------

	if(%containerCount >= 1)
	{
		//Register new notification object
		%notification = %this.newNotificationObject(%headString,%bodyString,%breakTime,false);
		
		//Set the body text on the notification interface
		//------------------------------------------------------------------------------------------------------------
		%notification.headCtrl.setText("<shadow:2:2><shadowcolor:000000><font:impact:18><just:center><color:FFFFFF>" @ %headString);
		%notification.bodyCtrl.setText("<shadow:2:2><shadowcolor:000000><font:impact:20><just:center><color:FFFFFF>" @ %bodyString);
		//------------------------------------------------------------------------------------------------------------
	}
	else
	{
		//Register new notification object
		%notification = %this.newNotificationObject(%headString,%bodyString,%breakTime,true);
		
		//Set the body text on the notification interface & play animation
		//------------------------------------------------------------------------------------------------------------
		%notification.headCtrl.setText("<shadow:2:2><shadowcolor:000000><font:impact:18><just:center><color:FFFFFF>" @ %headString);
		%notification.bodyCtrl.setText("<shadow:2:2><shadowcolor:000000><font:impact:20><just:center><color:FFFFFF>" @ %bodyString);
		%notification.dropInView();
		//------------------------------------------------------------------------------------------------------------
	}

	return %notification;
}

//           Initialize notification object
//---------------------------------------------------------------------------------
function BS_Interface::newNotificationObject(%this,%headString,%bodyString,%breakTime,%notificationEventBool)
{	
	//Build the notification object
	%notification = %this.buildNotificationObject(%notificationEventBool);
	
	//Initialize the object
	//---------------------------------------------------------------
	%notification.animateReady = false;
	%notification.breakTime = %breakTime;
	
	%canvas = %this.getActiveCanvas();
	%notification.canvas = %canvas;
		
	%notification.bodyCtrl = %notification.getObject(1);
	%notification.headCtrl = %notification.getObject(0).getObject(0);
	%notification.exX = getWord(%notification.extent,0);
	%notification.exY = getWord(%notification.extent,1);
	%notification.posX = getWord(%notification.position,0);
	%notification.posY = getWord(%notification.position,1);
	//---------------------------------------------------------------
	
	//Add notification object to said container
	//----------------------------------------------
	BS_InterfaceContainer.add(%notification);
	BS_InterfaceContainer.pushToBack(%notification);
	//----------------------------------------------
	
	%notification.time = getSimTime();

	return %notification;
}

//                 Builds the notification interface
//------------------------------------------------------------------
function BS_Interface::buildNotificationObject(%this,%notificationEventBool)
{
	//Shadow
	//------------------------------
	%shadow = new GuiSwatchCtrl() {
	  //profile = "GuiDefaultProfile";
	  //horizSizing = "right";
	  //vertSizing = "bottom";
	  position = "3 3";
	  extent = "350 95";
	  //minExtent = "8 2";
	  visible = "1";
	  color = "0 0 0 200";
	};
	//------------------------------
	
	if(%notificationEventBool)
	{
      %notificationEvent = new GuiMouseEventCtrl(BS_notificationEvent) {
        //profile = "GuiDefaultProfile";
        //horizSizing = "right";
        //vertSizing = "bottom";
        position = "0 0";
        extent = "350 95";
        //minExtent = "8 2";
        //visible = "0";
        //lockMouse = "0";
       };
	}
	
	//Notification object
	//-----------------------------------------------------------------------------
	%notification = new GuiSwatchCtrl() {
	  //profile = "GuiDefaultProfile";
	  //horizSizing = "right";
	  //vertSizing = "bottom";
	  position = "0 0";
	  extent = "350 95";
	  //minExtent = "8 2";
	  //visible = "1";
	  color = "200 200 200 255";

	  new GuiSwatchCtrl() {
		 //profile = "GuiDefaultProfile";
		 //horizSizing = "right";
		 //vertSizing = "bottom";
		 position = "0 0";
		 extent = "350 19";
		 //minExtent = "8 2";
		 //visible = "1";
		 color = "0 100 200 255";

		 new GuiMLTextCtrl() {
			//profile = "HUDChatTextEditSize4Profile";
			//horizSizing = "center";
			//vertSizing = "center";
			position = "2 0";
			extent = "344 18";
			//minExtent = "8 2";
			//visible = "1";
			//lineSpacing = "2";
			//allowColorChars = "0";
			//maxChars = "-1";
			text = "<font:impact:18><just:center>Blockland Streaming Notification!";
			//maxBitmapHeight = "-1";
			selectable = "0";
		 };
	  };
	  new GuiMLTextCtrl() {
		// profile = "HUDChatTextEditSize4Profile";
		 //horizSizing = "center";
		 //vertSizing = "center";
		 position = "5 20";
		 extent = "340 95";
		 //minExtent = "8 2";
		 //visible = "1";
		 //lineSpacing = "2";
		 //allowColorChars = "0";
		 //maxChars = "-1";
		 text = "<font:impact:18> Some text.";
		 //maxBitmapHeight = "-1";
		 selectable = "0";
	  };
	  new GuiSwatchCtrl() {
		 //profile = "GuiDefaultProfile";
		// horizSizing = "right";
		 //vertSizing = "bottom";
		 position = "143 59";
		 extent = "64 29";
		 //minExtent = "8 2";
		 visible = "1";
		 color = "150 150 150 255";

		 new GuiMLTextCtrl() {
			//profile = "HUDChatTextEditSize4Profile";
			//horizSizing = "center";
			//vertSizing = "center";
			position = "0 0";
			extent = "64 29";
			//minExtent = "8 2";
			//visible = "1";
			//lineSpacing = "2";
			//allowColorChars = "0";
			//maxChars = "-1";
			text = "<font:impact:30><just:center>Go";
			//maxBitmapHeight = "-1";
			selectable = "0";
		 };
	  };
	};
	//-----------------------------------------------------------------------------
	
	//Register object properties
	//-----------------------------------------
	%notification.shadow = %shadow;
	
	if(%notificationEventBool)
	{
		%notification.notificationEvent = %notificationEvent;
		%notificationEvent.parent = %notification;
		BS_interfaceContainer.activeNotification = %notification;
		
		%button = new GuiBitmapButtonCtrl() 
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "322 68";
			extent = "22 22";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "./images/expand";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			command = "bs_interface.expandNotification();";
			mColor = "255 255 255 255";
		};
		  
		%notificationEvent.add(%button);
	}
	   
	%notification.breakReg = 0;
	%notification.time = getSimTime();
	%shadow.parent = %notification;
	//------------------------------------------
	
	return %notification;
}

function BS_Interface::getActiveCanvas(%this)
{
	if(newChatHud.isAwake())
	{
		%canvas = newchathud;
	}
	else
	if(consoleDlg.isAwake())
	{
		%canvas = canvas.getObject(canvas.getCount()-2);
	}
	else
	{
		%canvas = canvas.getObject(canvas.getCount()-1);
	}
		
	return %canvas;
}

function BS_Interface::setOnCanvas(%this,%notification,%shadow,%event)
{
	%canvas = %this.getActiveCanvas();
	
	//if(%canvas.getName() $= "NewChatHud")
	//	if(nmh_type.isAwake())
	//	{
	//		%type = getSubStr(nmh_channel.getvalue(),0,strLen(nmh_channel.getValue())-1);
	//		%respond = true;
	//	}
	
	if(isObject(%shadow))
		%canvas.add(%shadow);
		
	if(isObject(%notification))
		%canvas.add(%notification);
	
	if(isObject(%event))
		%canvas.add(%event);
	
	//if(%respond $= "1")
	//{
	//	//nmh_type.makeFirstResponder(1);
	//	newMessageHud.open(%type);
	//}
		
}

//Pushes the next notification in the current line up
//---------------------------------------------------
function BS_Interface::nextNotificationGo(%this)
{
	//Initialize
	//------------------------------
	%group = BS_InterfaceContainer;
	%groupCount = %group.getCount();
	//------------------------------

	if(%groupCount >= 1)
	{
		//Get next notification by longest waiting time
		%nextNotification = %this.nextNotificationByTime();
		
		//echo("next notification's canvas = "@%nextNotification.canvas.getname());
		
		//Create a mouse event
		//------------------------------------------------
		%notificationEvent = new GuiMouseEventCtrl(BS_notificationEvent) 
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "350 95";
			minExtent = "8 2";
			visible = "0";
			lockMouse = "0";
		};
		
		%button = new GuiBitmapButtonCtrl() 
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "322 68";
			extent = "22 22";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "./images/expand";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			command = "bs_interface.expandNotification();";
			mColor = "255 255 255 255";
		};
		  
		%notificationEvent.add(%button);
		//------------------------------------------------
		
		//Active notification
		%group.activeNotification = %nextNotification;
		
		//Set the mouse event's parent to the notification
		%notificationEvent.parent = %nextNotification;
		
		//Tag notification object with mouse event
		%nextNotification.notificationEvent = %notificationEvent;
		
		%canvas = %this.getActiveCanvas();
		%nextNotification.canvas = %canvas;
		
		//Begin animation process
		%nextNotification.dropInView();
	}
	else
		return "EMPTY";
}

//  Returns the next notification by waiting time
//-------------------------------------------------
function BS_Interface::nextNotificationByTime(%this)
{
	//Initialize
	//--------------------------------------
	%container = BS_InterfaceContainer;
	%containerCount = %container.getCount();
	%time = getSimTime();
	%tempNot = 0;
	//--------------------------------------

	for(%i=0;%i<%containerCount;%i++)
	{
		//Get object %i from container
		%o = %container.getObject(%i);

		if(%tempNot $= "0")
		{
			//Set temp notification to object
			%tempNot = %o;
			%ai = 0;
		}
		else  
		if(%time - %o.time >= %time - %tempNot.time)
		{
			//set temp notification to object
			%tempNot = %o;
			%ai = %i;
		}
	}

	if(%tempNot !$= "0")
		%container.activeNotification = %ai;

	return %tempNot;
}

function bs_interface::expandNotification(%this)
{
	%o = bs_interfaceContainer.activeNotification;
	%link = %o.topicLink;
	
	if(%link !$= "")
	{
		$BS::oldStyle = BS_Line.htmlParseStyle;
		$BS::parseCommand = "ExpandNotification";
		BS_Line.htmlParseStyle = "lastResponse";
		BS_Line.get("forum.blockland.us:80",%link);
	}
}


//**************************************************************
//************ Notification Object - Animations ****************
//**************************************************************


//Drops swatch notification from the top of the window
//----------------------------------------------------
function guiSwatchCtrl::dropInView(%this)
{
	//Cancel any current pending loops
	if(isEventPending(%this.dropInViewLoop))
		cancel(%this.dropInViewLoop);
	
	//Get current blockland resolution
	//and set X & Y extent variables
	//-----------------------------------
	%res = getRes();
	
	%swatchExX = getWord(%this.extent,0);
	%swatchExY = getWord(%this.extent,1);
	//-----------------------------------
	
	if(!%this.animateReady)
	{
		//Play notification sound
		alxPlay(BS_NotificationSound);
		
		//Get the middle of the resolution
		//and set notification accordingly
		//--------------------------------
		%mid = %res / 2;
		%mid = %mid - (%swatchExX / 2);
		%this.position = %mid SPC (0 - %swatchExY);
		//--------------------------------
		
		//Add objects to the canvas
		//---------------------------------
		%this.canvas.add(%this.shadow);
		%this.canvas.add(%this);
		%this.canvas.add(%this.notificationEvent);
		//---------------------------------
		
		//We are now ready to animate
		%this.animateReady = true;
	}
	
	%break = 0;
	
	//Get the current position of the notification and move the objects down by 10 degrees
	//-----------------------------------------------------------------------------------------
	%swatchPosX = getWord(%this.position,0);
	%swatchPosY = getWord(%this.position,1);
	
	%this.position = %swatchPosX SPC (%swatchPosY + 10);
	%this.shadow.position = (getWord(%this.position,0) + 4) SPC (getWord(%this.position,1) + 2);
	//------------------------------------------------------------------------------------------
	
	if(getWord(%this.position,1) >= %break)
	{
		//Break time
		//-----------------------------------------------
		%this.position = getWord(%this.position,0) SPC 0;
		%breakTime = %this.breakTime;
		%this.onBreak();
		//-----------------------------------------------
		
		return "Break";
	}
	else
		%this.dropInViewLoop = %this.schedule(1,dropInView);
}

//Idle the swatch, prep for elevation
//-----------------------------------
function guiSwatchCtrl::onBreak(%this)
{
	//Get break time
	%breakTime = %this.breakTime;	
	
	//Set up objects for activity
	//-----------------------------
	%this.notificationEvent.setVisible(1);
	%this.add(%this.notificationEvent);
	%this.animationReady = false;
	//-----------------------------
	
	//Deploy schedule
	%this.breakSched = %this.schedule(%breakTime,elevateFromView);
}

//Slide given notification up & away!
//-------------------------------------------
function guiSwatchCtrl::elevateFromView(%this)
{
	//Cancel any pending loops
	if(isEventPending(%this.elevateFromViewLoop))
		cancel(%this.elevateFromViewLoop);
	
	//Get current blockland resolution
	//and set X & Y extent variables
	//-----------------------------------
	%res = getRes();
	
	%swatchExX = getWord(%this.extent,0);
	%swatchExY = getWord(%this.extent,1);
	//-----------------------------------
	
	if(!%this.animateReady)
	{
		//Remove the mouse event, getting ready for cleanup
		%this.notificationEvent.delete();
		
		//Ready to animate
		%this.animateReady = true;
	}
	
	%break = 0 - %swatchExY;
	
	//Get the current position of the notification and move the objects up by 10 degrees
	//------------------------------------------------------------------------------------------
	%swatchPosX = getWord(%this.position,0);
	%swatchPosY = getWord(%this.position,1);
	
	%this.position = %swatchPosX SPC (%swatchPosY - 10);
	%this.shadow.Position = (getWord(%this.position,0) + 4) SPC (getWord(%this.position,1) + 2);
	//------------------------------------------------------------------------------------------
	
	if(getWord(%this.position,1) <= %break)
	{
		//Get group container and
		//remove notification
		//------------------------
		%group = %this.getGroup();
		%group.remove(%this);
		//------------------------
		
		//Delete notification
		%this.delete();
		
		//Deploy next notification in line - if any
		BS_Interface.schedule(100,nextNotificationGo);
      
		return "Kill";
	}
	else
		%this.elevateFromViewLoop = %this.schedule(1,elevateFromView);
}

//**************************************************************
//*********** Notification Object - Mouse Events ***************
//**************************************************************


//Calls when the mouse button is down
//----------------------------------------------------	
function BS_notificationEvent::onMouseDown(%this,%a,%b,%c,%d)
{
	//Get the swatch ctrl
	//from the mouse event
	%group = %this.parent;

	//Set the go button's dimensions
	//----------------------------------------------------
	%eventArea1 = getWord(%group.position,0) + 150 SPC 60;
	%eventArea2 = getWord(%group.position,0) + 200 SPC 87;
	//----------------------------------------------------
	
	//Create a box for the button
	//----------------------------
	%ex1 = getWord(%eventArea1,0);
	%ey1 = getWord(%eventArea1,1);

	%ex2 = getWord(%eventArea2,0);
	%ey2 = getWord(%eventArea2,1);
	//----------------------------
	
	//Mouse pos X & Y
	//------------------
	%bx = getWord(%b,0);
	%by = getWord(%b,1);
	//------------------

	if((%bx >= %ex1 && %by >= %ey1) && (%bx <= %ex2 && %by <= %ey2))
	{
		// * When clicking the go button, execute below * \\
		//------------------------------------------------\\
		
		//Set container to local variable
		%BS_IC = BS_InterfaceContainer;
		
		//Get active notification
		%activeNotification = %BS_IC.activateNotification;
		
		//Get the current link
		%link = %group.topicLink;
		
		if(%link !$= "")
			goToWebPage(%link);

		//Cancel the break schedule and do the exit animation
		//------------------------------------------------------
		cancel(%this.breakSched);

		%BS_IC.getObject(%activeNotification).elevateFromView();
		//------------------------------------------------------
	}
}

//    When a mouse enters the mouse event control
//----------------------------------------------------
function BS_notificationEvent::onMouseEnter(%this,%a,%b,%c,%d)
{
	//Cancel any pending loops
	if(isEventPending(%this.buttonWatch))
		cancel(%this.buttonWatch);

	//Get the swatch ctrl
	//from the mouse event
	%group = %this.parent;

	//Set the go button's dimensions
	//----------------------------------------------------
	%eventArea1 = getWord(%group.position,0) + 150 SPC 60;
	%eventArea2 = getWord(%group.position,0) + 200 SPC 87;
	//----------------------------------------------------
	
	//Create a box for the button
	//----------------------------
	%ex1 = getWord(%eventArea1,0);
	%ey1 = getWord(%eventArea1,1);

	%ex2 = getWord(%eventArea2,0);
	%ey2 = getWord(%eventArea2,1);
	//----------------------------

	//Mouse pos X & Y
	//------------------
	%bx = getWord(%b,0);
	%by = getWord(%b,1);
	//------------------
	
	//Cursor position redefined
	%b = canvas.getCursorPos();

	if(!%this.breakReg)
	{
		//Stops the swatch from elevating out of the view
		//when the user's mouse is hovering over it
		//---------------------------------------------------
		%timeRemaining = getTimeRemaining(%group.breakSched);
		%this.breakTime = %timeRemaining;
		
		cancel(%group.breakSched);
		//---------------------------------------------------
		
		//Break registered set
		%this.breakReg = true;
	}

	if((%bx >= %ex1 && %by >= %ey1) && (%bx <= %ex2 && %by <= %ey2))
	{   
		//Change the swatch color of
		//the so called button
		//-----------------------------
		%swatch = %group.getObject(2);
		%swatch.color = "80 80 80 255";
		//-----------------------------
	}
	else
	{
		%swatch = %group.getObject(2);
		
		if(%swatch.color !$= "150 150 150 255")
			%swatch.color = "150 150 150 255";
	}

	%this.buttonWatch = %this.schedule(1,onMouseEnter,%a,%b,%c,%d);
}

//    When a mouse leaves the mouse event control
//-----------------------------------------------------
function BS_notificationEvent::onMouseLeave(%this,%a,%b,%c,%d)
{
   cancel(%this.buttonWatch);
   
   %this.breakReg = 0;
   
   %group = %this.parent;
   %group.breakSched = %group.schedule(%group.timeRemaining,onBreak);
   
   %swatch = %group.getObject(2).color = "150 150 150 255";
}

package BS_InterfaceSupport
{
	function canvas::setContent(%this,%content)
	{
		parent::setContent(%this,%content);
		
		%notification = BS_interfaceContainer.activeNotification;
		
		if(isObject(%notification))
		{
			BS_Interface.setOnCanvas(%notification,%notification.shadow,%notification.event);
		}
		
		%bs_Menu = %this.bs_menu;
		
		if(isObject(%bs_Menu))
		{
			BS_Interface.setOnCanvas(%bs_menu,%bs_menu.button);
			//BS_Interface.buildEvent();
		}
	}
	
	function canvas::pushDialog(%this,%obj)
	{
		parent::pushDialog(%this,%obj);
		
		%notification = BS_interfaceContainer.activeNotification;
		
		if(isObject(%notification))
			BS_Interface.setOnCanvas(%notification,%notification.shadow,%notification.event);
			
		%bs_menu = %this.bs_menu;
		
		if(isObject(%bs_menu))
		{
			//BS_Interface.buildEvent();
			BS_Interface.setOnCanvas(%bs_menu,%bs_menu.button);
		}
	}
	
	function canvas::popDialog(%this,%obj)
	{
		parent::popDialog(%this,%obj);
		
		%notification = BS_interfaceContainer.activeNotification;
		
		if(isObject(%notification))
		{
			BS_Interface.setOnCanvas(%notification,%notification.shadow,%notification.event);
		}		
		
		%bs_Menu = %this.bs_menu;
		
		if(isObject(%bs_Menu))
		{
			//BS_Interface.buildEvent();
			BS_Interface.setOnCanvas(%bs_menu,%bs_menu.button);
		}
		
	}
};
activatePackage(BS_InterfaceSupport);